unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFMain = class(TForm)
    Panel1: TPanel;
    BnStartSchueler1: TButton;
    Memo1: TMemo;
    BnStartSchueler2: TButton;
    BnStartSchueler3: TButton;
    BnStartKoerper1: TButton;
    BnStartKoerper2: TButton;
    BnStartKoerper3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BnStartSchueler1Click(Sender: TObject);
    procedure BnStartSchueler2Click(Sender: TObject);
    procedure BnStartSchueler3Click(Sender: TObject);
    procedure BnStartKoerper1Click(Sender: TObject);
    procedure BnStartKoerper2Click(Sender: TObject);
    procedure BnStartKoerper3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

uses Schueler,
     Koerper,
     CBasis;

procedure TFMain.FormCreate(Sender: TObject);
begin
  Memo1.Clear();
  Memo1.Align := alClient;
end;

procedure TFMain.BnStartSchueler1Click(Sender: TObject);
var s1: CSchueler;
var s2: CSchueler;
begin
  Memo1.clear();
  s1 := CSchueler.create('Mueller', 7);
  Memo1.Lines.Add(  s1.toString() );

  s2 := CSchueler.create('Schmidt', 12);
  Memo1.Lines.Add(  s2.toString() );

  s2.setKlasse( s2.getKlasse() + 2 );
  Memo1.Lines.Add(  s2.toString() );
end;

procedure TFMain.BnStartSchueler2Click(Sender: TObject);
var schule:array[0..2] of CSchueler;
    i:integer;
begin
  Memo1.clear();
  Memo1.Lines.Add(  'Schler mit einem Array' );
  schule[0] := CSchueler.create('Meier', 3);
  schule[1] := CSchueler.create('Mueller', 7);
  schule[2] := CSchueler.create('Koch', 11);
  for i:=0 to 2 do
  begin
    Memo1.Lines.Add(  schule[i].toString() );
  end;
end;

procedure TFMain.BnStartSchueler3Click(Sender: TObject);
var schule:TList;
    i:integer;
    sch:CSchueler;
    summe, xm:double;
begin
  schule:=TList.Create();
  Memo1.clear();
  Memo1.Lines.Add(  'Schler mit TList' );
  schule.add( CSchueler.create('Meier', 3) );
  schule.add( CSchueler.create('Mueller', 9) );
  schule.add( CSchueler.create('Koch', 11) );
  for i:=0 to schule.count-1 do
  begin
    sch := schule.items[i];
    Memo1.Lines.Add(  sch.toString() );
  end;

  summe := 0.0;
  for i:=0 to schule.count-1 do
  begin
    sch := schule.items[i];
    summe:=summe+sch.getKlasse();
  end;
  xm := summe / schule.Count;
  Memo1.Lines.Add(  'Mittelwert: '+DoubleStr2(xm) );

  // speicher freigeben
  for i:=0 to schule.count-1 do
  begin
    sch := schule.items[i];
    sch.free();
  end;
  schule.free();
end;

procedure TFMain.BnStartKoerper1Click(Sender: TObject);
var kg1:CKugel;
    q1:CQuader;
    w1:CWuerfel;
    krp:CKoerper;
    q2:CQuader;
    krp2:CKoerper;
begin
  Memo1.clear();
  q1 := CQuader.create('q1', 4.0,5.0,6.0);
  Memo1.Lines.Add(  q1.toString() );

  w1 := CWuerfel.create('w1', 4.0);
  Memo1.Lines.Add(  w1.toString() );

  kg1:=CKugel.create('kg1', 6);
  // jetzt wird die zweite toString Methode aufgerufen
  Memo1.Lines.Add(  kg1.toString() );

  krp := q1;  // Quader auf Koerper
  Memo1.Lines.Add(  'Krper(Quader):' +krp.toString() );

  q2 := CQuader(krp);
  Memo1.Lines.Add(  q2.toString() );

  krp2 := w1.add(q1).add(kg1);
  Memo1.Lines.Add(  'Volumen nach add: '+DoubleStr2(krp2.getVolumen()) );
  Memo1.Lines.Add(  krp2.toString() );

  Memo1.Lines.Add(  '' );
  Memo1.Lines.Add(  w1.toString() );
  // Test auf virtuelle Methode
  Memo1.Lines.Add(  CKoerper(w1).toString() );
end;

procedure TFMain.BnStartKoerper2Click(Sender: TObject);
var kg1:CKugel;
    q1:CQuader;
    w1:CWuerfel;
    krp:CKoerper;
var korb:array[0..2] of CKoerper;
    i:integer;
begin
  Memo1.clear();
  Memo1.Lines.Add(  'Korb mit Krpern in einem Array' );
  korb[0] := CQuader.create('q1', 4.0,5.0,6.0);
  korb[1] := CWuerfel.create('w1', 4.0);
  korb[2] := CKugel.create('kg1', 6);
  for i:=0 to 2 do
  begin
    Memo1.Lines.Add(  korb[i].toString() );
  end;
end;

procedure TFMain.BnStartKoerper3Click(Sender: TObject);
var kg1:CKugel;
    q1:CQuader;
    w1:CWuerfel;
    krp:CKoerper;
var korb:TList;
    i:integer;
begin
  korb:=TList.Create();
  Memo1.clear();
  Memo1.Lines.Add(  'Korb mit Krpern in einer TList' );
  korb.add( CQuader.create('q1', 4.0,5.0,6.0) );
  korb.add( CWuerfel.create('w1', 4.0) );
  korb.add( CKugel.create('kg1', 6) );
  for i:=0 to korb.count-1 do
  begin
    krp := korb.items[i];
    Memo1.Lines.Add(  krp.toString() );
  end;

  // speicher freigeben
  for i:=0 to korb.count-1 do
  begin
    krp := korb.items[i];
    krp.free();
  end;
  korb.free();
end;

end.
